/*
  divisors.c

  Copyright (C) 2015 Taiji Yamada <taiji@aihara.co.jp>
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <libgen.h>
#include <math.h>
#include "prime_util.h"

void stdout_divisors(const huge_uint n)
{
  huge_uint d = 1, sqrt_n;

  sqrt_n = sqrt(n);
  for (; d<=sqrt_n; ++d)
    if (n%d == 0) {
      printf("%llu\t", d);
      if (d != n/d) printf("%llu\t", n/d);
    }
  printf("\n");
}

int usage(FILE *fp, int argc, char *argv[])
{
  (void)argc;
  fprintf(fp, "Usage:\n\t%s number [...]\n", basename(argv[0]));
  return fp == stderr ? 1 : 0;
}
int main(int argc, char *argv[])
{
  int a;

  if (argc < 2) return usage(stderr, argc, argv);
  for (a=1; a<argc; ++a)
    stdout_divisors(atoll(argv[a]));
  
  return 0;
}
