/*
  totient_function.c

  Copyright (C) 2015 Taiji Yamada <taiji@aihara.co.jp>
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <libgen.h>
#include "prime_util.h"

int usage(FILE *fp, int argc, char *argv[])
{
  (void)argc;
  fprintf(fp, "Usage:\n\t%s [-l lower] [-u upper]\n", basename(argv[0]));
  return fp == stderr ? 1 : 0;
}
int main(int argc, char *argv[])
{
  int a, fd;
  huge_uint n, l = 1, u = 10000, n_return;
  isprime_bit_table_element_t *isprime_bit_table;

  for (a=1; a<argc; ++a)
    if (strcmp(argv[a], "-h") == 0)
      return usage(stderr, argc, argv);
    else if (strcmp(argv[a], "-l") == 0 && a+1 < argc)
      l = atoll(argv[++a]);
    else if (strcmp(argv[a], "-u") == 0 && a+1 < argc)
      u = atoll(argv[++a]);
    else
      break;

  isprime_bit_table = isprime_bit_table_mmap(u, &n_return, &fd);
  if (!isprime_bit_table) abort();
  primes_bit_continued_eratosthenes_sieve(n_return, isprime_bit_table, u);
  for (n = l; n < u; ++n)
    printf("%llu\t%llu\n", n, totient_function(u, isprime_bit_table, n));

  return 0;
}
